package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class AjusteInventarioPage extends PageBase {

    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    By campoDoFiltro = By.xpath("//*[@class='zh-business-color-popup-header']");

    //Aplicando os paramentros no Filtro inicial:
    By clearFilter = By.xpath("//*[@data-zh-title-tooltip='Clear Filter (Ctrl+Backspace)']");
    By UnidadeAjusteIventarioIcon = By.xpath("//*[@id='NMFILIAL']/span");
    By UnidadeAjusteIventarioAux = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[2]/span");
    By IconeData = By.xpath("//*[@class = 'zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By UnidadeAjusteIventarioIcon2 = By.xpath("//*[@id='NMOPERADOR']/span");

    By campoOperador = By.xpath("//*[@id='NMOPERADOR']/input");

    By btnRefresh = By.xpath("//*[@data-zh-id = 'zh-floating-control-refresh']//span[1]");
    By btnFloatControl = By.xpath("//*[@data-zh-id = 'zh-floating-control-handle']");
    By btnSeta = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[3]/span[2]");
    By IconProcurar = By.xpath("//*[@id='search']//*[@id='path15756']");
    By campoProcurar = By.xpath("//*[@class='mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By codOperador = By.xpath("//*[@id='grid-9000']//*[.='000000021846']");
    //By operador = By.xpath("//*[@id='grid-9000']//*[.='Sandro Siilva']");
    By operador = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[2]/span");
    By aplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");

    //Adicionando Ajuste de inventario:
    By btnAdicionar = By.xpath("//*[@id='footer']/div[2]/ul/li[1]/a/div");
    By btnAdicionar2 = By.xpath("//*[@data-zh-id='20852794697104433322483']");
    By caixaTextoAjusteIventario = By.xpath("//*[@class='zh-text-alert']");
    By btnOkAlert = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
    By btnXlimpar = By.xpath("//*[@zh-icon ='no-border close-x']");
    By btnCalendario = By.xpath("//*[@id='calendar']");
    By DataEscolhida = By.xpath("//*[@id='zh-calendar-Widget']//*[.='11']");
    By campoDescricao = By.xpath("//*[@zh-id='208527946936254289722511']");
    By btnSalvar = By.xpath("//*[@data-zh-id='208527946937190993162526']");
    By btnIcon = By.xpath("//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produto = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[2]/span");
    By btnXlimpar2 = By.xpath("//*[@id='CDALMOXARIFE']/span[2]");
    By btnIconAlmoxarifado = By.xpath("//*[@id='CDALMOXARIFE']/span ");
    By almoxarifado = By.xpath("//*[@id='grid-9000']/div[2]/div/div[1]/div[2]/span");
    By confirmar = By.xpath("//*[@data-zh-id='4']");
    By btnIconLote = By.xpath("//*[@id='NRLOTEESTQ']/span");
    By lote = By.xpath("//*[@id='grid-9000']/div[2]/div/div[3]/div[1]/span");
    By quantidadeProduto = By.xpath("//*[@zh-id='208527946938333229262469']");
    By btnSalvar2 = By.xpath("//*[@data-zh-id='208527946940788756772491']");
    By btnAtualizarEstoque = By.xpath("//*[@data-zh-id='20852794699063680472493']");
    By btnGravar = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");
    By caixaTextoEstoqueAtualizadoComSucesso = By.xpath("//*[@class='zh-container-alert']");
    By BtnOk = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

    //Editar ajuste iventario
    By localizandoDescrição = By.xpath("//*[.='Testes Automatizados']");
    By localizandoDescriçãoExcluir = By.xpath("//*[.='Deletar']");
    By btnEditar = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946928758746902516']");
    By btnExcluir = By.xpath("//*[@id='footer']//*[@data-zh-id ='208527946938725575942522']");
    By AlertExcluirRegistro = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-container-text-alert']");
    //By AlertExcluirRegistro2 = By.xpath("//*[@class='zh-container-alert']//*[@class='zh-text-alert']']");

    By btnSim = By.xpath("//*[@class='zh-container-alert']//*[@data-zh-id='zh-footer-alert-button-0']");
    By campoDescricao2 = By.xpath("//*[@zh-id='208527946936254289722511']");
    By abaProduto = By.xpath("//*[@data-zh-id='masterDetailTabbedWidget']//li[2]/label");
    By clickCampoQuantidade = By.xpath("//*[@data-zh-field-name='QTTOTLANCTO']//div[1]");
    By sendKeysCampoQuantidade = By.xpath("//*[@data-zh-field-name='QTTOTLANCTO']//input");
    By btnSalvarAlteracoes = By.xpath("//*[@id='footer']//*[.='Salvar alterações']");
    By clickBody = By.xpath("//*[@id='grid-208527946914805240252460']/div[2]/div");
    By btnEstoqueAtualizadoComSucesso= By.xpath("//*[@class='zh-footer-alert']//button ");




    public void preencherFiltroAjusteIventario(String nomeOperador){

        //FILTRO INICIAL:
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(UnidadeAjusteIventarioIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(UnidadeAjusteIventarioAux);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(campoDoFiltro);
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automatico.
        click(BtnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(campoDoFiltro);
        //click(UnidadeAjusteIventarioIcon2);
        waitForInvisibilityOfElementLocated(loadingWait);


        click(campoOperador);
        sendKeys(campoOperador,nomeOperador);

        /* // trecho que faz a busca pelo icone procurar
        click(btnSeta);
        click(btnSeta);
        click (btnRefresh);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconProcurar);
        click(IconProcurar);
        click(campoProcurar);
        sendKeys(campoProcurar,nomeOperador);
        waitForVisibilityOfElementLocated(codOperador);
        click(codOperador);
         */

        //waitForVisibilityOfElementLocated(operador);
        //click(operador);
        click(campoDoFiltro);
        click(aplicarFiltro);

    }

    public void AdicionarAjusteIventario(String quantidade, String cmpDesc){
        //INICIO:
        click(btnAdicionar);
        //SUB-ABA AJUSTE DE INVENTARIO:
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        click(btnOkAlert);
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
        waitForVisibilityOfElementLocated(btnCalendario);
        click(btnCalendario);
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        click(campoDescricao);
        sendKeys(campoDescricao,cmpDesc);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ABA PRODUTOS:
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIcon);
        click(btnIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //SUB FILTRO - INFORMAÇOES COMPLEMENTARES DO PRODUTO:
        waitForVisibilityOfElementLocated(btnXlimpar2);
        click(btnXlimpar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnIconLote);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(lote);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ABA PRODUTOS:
        click(quantidadeProduto);
        sendKeys(quantidadeProduto,quantidade);
        waitForVisibilityOfElementLocated(btnSalvar2);
        click(btnSalvar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        //CAIXA DE ALERTA-02:
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        click(btnGravar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(caixaTextoEstoqueAtualizadoComSucesso);
        click(BtnOk);
    }

    public void EditarAjusteIventario(String cmpDesc2, String quantidade){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescrição);
        click(localizandoDescrição);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnEditar);
        //waitForVisibilityOfElementLocated(campoDescricao2);
        //click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2,cmpDesc2);
        waitForVisibilityOfElementLocated(btnSalvar);
        click(btnSalvar);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(abaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(clickCampoQuantidade);
        click(clickCampoQuantidade);
        waitForVisibilityOfElementLocated(sendKeysCampoQuantidade);
        sendKeys(sendKeysCampoQuantidade,quantidade);
        click(clickBody);
        waitForVisibilityOfElementLocated(btnSalvarAlteracoes);
        click(btnSalvarAlteracoes);
        waitForVisibilityOfElementLocated(btnAtualizarEstoque);
        click(btnAtualizarEstoque);
        waitForVisibilityOfElementLocated(caixaTextoAjusteIventario);
        waitForVisibilityOfElementLocated(btnGravar);
        click(btnGravar);
        waitForVisibilityOfElementLocated(btnEstoqueAtualizadoComSucesso);
        click(btnEstoqueAtualizadoComSucesso);
        //click(btnFloatControl);
        //click(btnRefresh);

    }


    public void ExcluirAjusteIventario(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(localizandoDescriçãoExcluir);
        click(localizandoDescriçãoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlertExcluirRegistro);
        click(btnOkAlert);

    }




}
